RESTORE FILES: Restore Files to Original RABNs from Offline Source

#### Search Results

Search

# RESTORE FILES: Restore Files to Original RABNs from Offline Source

The RESTORE FILES function restores files from a file or database SAVE data set created while the Adabas nucleus was inactive, or from a file SAVE data set created with UTYPE=EXU. One or more files can be restored. The files are restored into an existing database to their original RABNs.

Notes:

1. An interrupted RESTORE FILES operation must be reexecuted from the beginning. Until successful completion or reexecution of the restore operation, the files to be restored are inaccessible.
2. Checkpoint and security files from Adabas version 5 cannot be restored.

This document covers the following topics:

- Conditions

- Result

- Syntax

- Optional Parameters

- Examples

## Conditions

To use the RESTORE FILES function, the following conditions must be met:

1. The correct SAVE data set must be supplied. It can be a database or file SAVE data set and must contain the files to be restored.

2. A file may be restored using a SAVE data set created using a different database as long as identical device types are used.

3. An existing database must be present. The files to be restored may have originated from this or from a different database. SAVE data sets from Adabas version 5.1 or above can be used.

4. All RABNs originally used by the file(s) to be restored must either be free (available according to the Free Space Table) or be occupied by files to be overwritten.

5. The Adabas nucleus may be active or inactive on the output database.

   If the Adabas nucleus is active for restoring the checkpoint or security files, the ADASAV utility requires exclusive database control; that is, no user may be active on the database.

6. If the SAVE operation was performed with the DRIVES parameter, the SAVE data sets created can also be restored with the same DRIVES parameter. Alternatively, the SAVE data sets can be concatenated to a single SAVE data set for a RESTORE operation without the DRIVES parameter which then defaults to DRIVES=1. SAVE datasets can also be arranged in multiple concatenations for use with DRIVES values greater than one. In all cases the data sets must be in ascending order, but the sequence can be broken into separate concatenations at any point,

   For example, a SAVE taken with DRIVES=4 can be restored using DRIVES=1 by concatenating SAVE dataset 1 with 2, 3 and 4 in that order. DRIVES=2 may be used by concatenating dataset 1 with 2 and 3 with 4. When DRIVES is greater than 1, the RESTORE operation is performed from the separate DDRESTn files in parallel.

7. For restoring just a few files from a multivolume database SAVE data set, only those tape volumes that actually contain data of the files to be restored need to be supplied in the ADASAV job control. The job protocol of the SAVE operation as well as the corresponding SYNV checkpoints indicate the files or parts of files contained on each volume.

8. Expanded files and coupled files can only be restored or overwritten as a whole. That is, if one file in an expanded file is specified, all other files in the expanded file must be specified. If one file in a coupled relationship is specified, all other files in that relationship must be specified.

9. A checkpoint, security, trigger, or user-defined system file can be overwritten only by another checkpoint, security, trigger, or user-defined system file, respectively. A checkpoint, security, or trigger file cannot be restored if such a file already exists in the database with a different file number.

10. New file numbers can be assigned to the files to be restored using the NEWFILES parameter.

## Result

The result of this function is the specified files with the same physical status they had at the time of the ADASAV SAVE operation.

## Syntax

The FILES file list specifies one or more Adabas file numbers or a range of file numbers to be restored. Ranges of file numbers should be specified using a dash (-) in the format: `fnfirst-fnlast`.

For an Adabas expanded file, all component files of the expanded file including the anchor file must be specified. If a specified file is coupled to other files, the coupled files must also be specified.

The file list specified need not correspond to the file list used for the corresponding SAVE function. A file list may be specified even if no file list was used for the corresponding SAVE function.

A file may also be restored using a SAVE data set created using a different database as long as identical device types are used.

## Optional Parameters

> ALLOCATION: Action to Follow File Extent Allocation Failure

>   ALLOCATION specifies the action to be taken if file extent allocations cannot be obtained according to the placement parameters ACRABN, DSRABN, NIRABN, or UIRABN.

>   ALLOCATION pertains to the implicit RABN specifications derived from the files on the save data set.

>   By default (that is, ALLOCATION=FORCE), the utility terminates with error if any file extent allocation cannot be met according to RABN placement parameters.

>   If ALLOCATION=NOFORCE is specified and any allocation with placement parameters fails, the utility retries the allocation without the placement parameter.

> BUFNO: Count of Buffers Per Drive

>   The BUFNO value, multiplied by the DRIVES parameter value, allocates fixed buffers for RESTORE operation. A value of 2 or 3 usually provides optimum performance; up to 255 is possible. A value greater than 5, however, provides little advantage and allocates a lot of space. The default is 1 (one buffer per drive).

> DRIVES: Tape Drives for Parallel Restore

>   DRIVES is the number of tape drives to be used for parallel restore processing. The number can range 1 to 8, inclusively; the default is 1.

> EXCLUDE: Exclude Specified Files from Restore

>   EXCLUDE lists the numbers of the files to be excluded from the restore operation; that is, the files that are not to be restored. This list can include a list of more than one Adabas file number or a range of file numbers. Ranges of file numbers should be specified using a dash (-) in the format: `fnfirst-fnlast`.

>   The parameter is optional: if not specified, no files are excluded. A file number may be listed only once individually or in a range.

>   If the NEWFILES parameter:

>   - is not specified, all files specified in the EXCLUDE parameter must also be specified in the FILES parameter.

>   - is specified, all files specified in the EXCLUDE parameter must also be specified in the NEWFILES parameter. In this case, the file numbers specified in the EXCLUDE parameter refer to the new file numbers in NEWFILES, not to the old file numbers in the FILES parameter.

>   The EXCLUDE parameter is provided for use in recovery jobs built by the Adabas Recovery Aid (ADARAI).

> NEWFILES: New File Numbers

>   The NEWFILES parameter specifies the new file number to be assigned to each file specified by FILES. The parameter is optional: if no new file number is assigned to a file, the file retains its original number. NEWFILES may not be specified for expanded files, physically coupled files, or replicated files.

>   Note
>   The NEWFILES parameter is not allowed if a range of files is specified in the FILES parameter.

>   If a file with a number specified by NEWFILES already exists in the database, the corresponding file will not be restored unless the OVERWRITE parameter is also specified. If the file to be overwritten is password-protected, the corresponding PASSWORD parameter must also be specified.

>   If several files are to be restored, the list of file numbers in the NEWFILES parameter must correspond to the list of files in the FILES parameter. If no new file number is to be assigned to a file, its entry in the file number list of NEWFILES must be specified as zero. See the examples.

>   You can use NEWFILES to renumber a base file or LOB file only if both files of the LOB file group are restored. In this case, ADASAV assigns both files the new file numbers specified by the NEWFILES parameter and adjusts the links between the two files accordingly. However, if only one file of a LOB file group is restored, it cannot be assigned a new file number using the NEWFILES parameter; use the ADADBS or AOS RENUMBER function instead.

> NOUSERABEND: Termination without Abend

>   When a parameter error or a functional error occurs while this utility function is running, the utility ordinarily prints an error message and terminates with user abend 34 (with a dump) or user abend 35 (without a dump). If NOUSERABEND is specified, the utility will not abend after printing the error message. Instead, the message "utility TERMINATED DUE TO ERROR CONDITION" is displayed and the utility terminates with condition code 20.

>   Note
>   When NOUSERABEND is specified, we recommend that it be specified as the first parameter of the utility function (before all other parameters). This is necessary to ensure that its parameter error processing occurs properly.

> OVERWRITE: Overwrite Existing File

>   This parameter causes an existing file to be deleted and then restored. If a file which is to be restored is already present in the database, ADASAV will skip this file unless the OVERWRITE parameter is supplied.

>   Note
>   To avoid unintentionally overwriting the database, Software AG recommends that you always specify the OVERWRITE parameter after, and not before, the FILES file list.

> PASSWORD

>   PASSWORD specifies one password or a list of passwords if one or more files specified in FILES are password-protected. This only applies to files already in the database which are to be overwritten. If the NEWFILES parameter is specified, the PASSWORD parameter must specify the passwords related to the new file numbers.

>   When restoring more than one password-protected file, the correct passwords must be specified as positional values corresponding to the protected file numbers' positions in the FILES list. Refer to the examples for more information about the PASSWORD parameter. When overwriting password-protected files, the Adabas nucleus must be active.

> READONLY: Read-only Status Indicator

>   READONLY indicates whether the read-only status is on or off for a file or a list of files. Valid values for this parameter are "YES" (read-only status is on) and "NO" (read-only status is off).

>   When restoring more than one file, the read-only status must be specified as positional values corresponding to the file number positions in the FILES list.

>   If READONLY is not specified, the read-only status of the file will be the same as it was on the SAVE data set.

>   Note
>   The READONLY parameter is not allowed if a range of files is specified in the FMOVE parameter.

> RPLACTIVE: Reset the Replication Inactive Flag in the FCB

>   RPLACTIVE is an optional parameter that specifies the inactive flag setting for a file during restore processing. Valid inactive flag settings are "YES", "NO", or no setting at all. A setting of "YES" turns off the replication inactive flag (YFSTQRPI) for a file. A setting of "NO" turns on the replication inactive flag.

>   Note
>   This parameter can only be specified if you also have Adabas 8.2 SP2 or later installed.

>   If no setting is specified, the default value is used. The default depends on the target database ID of the restore processing and its replication state. If any of the following conditions are met, the default is "YES"; otherwise the default is "NO":

>   - The original replication is turned off.

>   - The restore DBID is not the same as the original saved DBID.

>   - The original replication target ID has been changed.

>   - The original replication-before-image has been changed.

>   - The replication primary key has changed.

>   - The original replication is turned off.

>   When restoring more than one file, the correct RPLACTIVE settings must be specified as positional values corresponding to the file numbers' positions in the FILES list. For example, if four files are listed in the FILES file list, the following might be the setting for the RPLACTIVE parameter:

>       RPLACTIVE='YES,NO,,YES'

>   In this example, the inactive flag is turned off (YES) for the first and fourth files and turned on (NO) for the second file. No value is provided for the third file, so an default appropriate for the file is used.

> RPLDATA: Send Data of the Restoring File to Replication Target ID

>   RPLDATA is an optional parameter that indicates whether the data in a file should be replicated to the replication target ID (RPLTARGETID parameter).

>   Note
>   This parameter can only be specified if you also have Adabas 8.2 SP2 or later installed.

>   Valid replication settings are "YES", "NO", "CREATE", or no setting at all. A setting of "YES" causes the restore function to replicate the file data to the replication target during restore processing. A setting of "NO" will not replicate the data to the replication target during restore processing. A setting of CREATE causes the restore function to replicate the file data to the replication target during restore processing, but also sends a "create file" transaction to the replication target. If no setting is specified, the default "NO" is used.

>   Note
>   Values of "YES" or "CREATE" can only be specified if replication is turned on for the corresponding file.

>   When restoring more than one file in the FILE file list, the RPLDATA settings must be specified as positional values corresponding to the file numbers' positions in the FILES list. For example, if four files are listed in the FILES file list, the following might be the setting for the RPLACTIVE parameter:

>       RPLDATA='YES,NO,,YES'

>   In this example, the data in the first and fourth files (YES) will be replicated to the replication target, but it will not be replicated for the second and third files (NO and no setting for the third file).

>   ADASAV RESTORE with the RPLDATA parameter will not replicate data for a file with spanned DS record support.

> RPLDSBI: Replication Data Storage Before Image

>   RPLDSBI is an optional parameter that indicates whether the collection of before images of data storage should occur for an update command to a file.

>   Note
>   This parameter can only be specified if you also have Adabas 8.2 SP2 or later installed.

>   Valid RPLDSBI settings are "YES", "NO", or no setting at all. A setting of "YES" indicates that the collection of before images of data storage will occur for the file during restore processing. A setting of "NO" indicates that the collection of before images of data storage will not occur for the file during restore processing.

>   If no setting is specified, the default value is used. The default depends on the target database ID of the restore processing and its replication state. If the restore DBID is the same as the originally saved DBID and REPLICATION=YES in the target DBID, the default is "YES"; otherwise the default is "NO".

>   Note
>   A values of "YES" can only be specified if replication is turned on for the corresponding file.

>   When restoring more than one file in the FILE file list, the RPLDSBI settings must be specified as positional values corresponding to the file numbers' positions in the FILES list. For example, if four files are listed in the FILES file list, the following might be the setting for the RPLDSBI parameter:

>       RPLDSBI='YES,NO,,YES'

>   In this example, the before images are collected for the first and fourth files (YES), but are not collected for the second file (NO). No value is provided for the third file, so an default appropriate for the file is used..

> RPLKEY: Primary Key for Replication

>   RPLKEY is an optional parameter that specifies the primary key for replication. Valid RPLKEY settings are a two-character field name, "OFF", or no setting at all. Specifying a field name identifies that field as the primary key for replication. A setting of "OFF" indicates that no primary key should be used for replication.

>   Note
>   This parameter can only be specified if you also have Adabas 8.2 SP2 or later installed.

>   If no setting is specified, the default value is used. The default depends on the target database ID of the restore processing and its replication state. If the restore DBID is the same as the originally saved DBID and REPLICATION=YES in the target DBID, the original RPLKEY value for the file is used; otherwise the default is "OFF".

>   Note
>   A primary key can only be set if replication is turned on for the file and if the field name is a valid Adabas field according to the field definition table (FDT) for the file. When a new RPLKEY is specified it will not be confirmed as a valid Adabas field until the end of the ADASAV run. At that time, if any RPLKEY is found to be invalid, a warning message is issued, the RPLKEY is set to "OFF", and condition code 8 is returned.

>   When restoring more than one file in the FILE file list, the RPLKEY settings must be specified as positional values corresponding to the file numbers' positions in the FILES list. For example, if four files are listed in the FILES file list, the following might be the setting for the RPLKEY parameter:

>       RPLKEY='AA,BB,,OFF'

>   In this example, field AA is used as the replication primary key for the first file, BB is used as the replication primary key for the second file, and no replication primary key is used for the fourth file (OFF). No value is provided for the third file, so an default appropriate for the file is used..

> RPLTARGETID: Replication Target ID

>   RPLTARGETID is an optional parameter that specifies the target ID of the Event Replicator Server to which the restored transactions should be sent.

>   Note
>   This parameter can only be specified if you also have Adabas 8.2 SP2 or later installed.

>   Valid RPLTARGETID settings are a valid target ID, "OFF", or no setting at all. Specifying a target ID identifies that as the target for replication. A setting of "OFF" or "0" indicates that no replication target should be used for replication.

>   If no setting is specified, the default value is used. The default depends on the target database ID of the restore processing and its replication state. If the restore DBID is the same as the originally saved DBID and REPLICATION=YES in the target DBID, the original RPLTARGETID value for the file is used; otherwise the default is "OFF".

>   Note
>   A replication target ID can only be specified if replication is turned on for the file.

>   When restoring more than one file in the FILE file list, the RPLTARGETID settings must be specified as positional values corresponding to the file numbers' positions in the FILES list. For example, if four files are listed in the FILES file list, the following might be the setting for the RPLTARGETID parameter:

>       RPLTARGETID='23,24,,OFF'

>   In this example, target ID 23 is used as the replication target for the first file, 24 is used as the replication target for the second file, and no replication target is used for the fourth file (OFF). No value is provided for the third file, so an default appropriate for the file is used..

> RPLUPDATEONLY: Allow Only Event Replicator Processing Updates

>   The RPLUPDATEONLY parameter can be used in the ADASAV RESTORE function to indicate whether an Adabas database file may be updated only by the Event Replicator Server as part of Adabas-to-Adabas replication or by other means as well. This parameter is optional.

>   Note
>   This parameter can only be specified if you also have Adabas 8.2 SP2 or later installed.

>   Valid values are "YES" or "NO". A value of "YES" indicates that the file can only be updated via Event Replicator processing; a value of NO indicates that the file can be updated by any normal means, including Event Replicator processing.

>   If no value is specified, the default RPLUPDATEONLY setting of the file at the time of the corresponding SAVE operation is used.

> TEST: Test Syntax

>   The TEST parameter tests the operation syntax without actually performing the operation. Only the syntax of the specified parameters can be tested; not the validity of values and variables.

## Examples

#### Example 1:

    ADASAV RESTORE   FILES=3,4,5,OVERWRITE,
    ADASAV      PASSWORD='PWD3,,PWD5'

Files 3, 4, and 5 are to be restored. Existing files 3, 4, and 5 are to be overwritten by the restored files. Passwords PWD3 and PWD5 are provided for files 3 and 5.

#### Example 2:

     ADASAV RESTORE FILES=11,12,13,14,OVERWRITE
     ADASAV          NEWFILES=16,0,17

Files 11, 12, 13, and 14 are to be restored. Files 11 and 13 are to be restored as files 16 and 17, respectively. The file numbers of files 12 and 14 will not be changed because the corresponding NEWFILES parameter values are specified as zero or omitted. Files 12, 14, 16, and 17 are to be overwritten, if already present in the database.

### On this page

- Conditions
- Result
- Syntax
- Optional Parameters
- Examples